<template>
    <div class="table-component">
        <div class="table-toolbar row">
            <div class="table-toolbar-search col">
                <i class="fa fa-search table-toolbar-search-icon"></i>
                <input class="table-toolbar-search-field" type="text" placeholder="Search">
            </div>
            <div class="table-toolbar-items col-auto">
                <button class="table-toolbar-item">
                    <i class="fa fa-plus"></i>
                </button>
            </div>
        </div>
        
        <div class="row">
            <div class="col">
                <h2 class="table-title" v-text="displayedTitle"></h2>
            </div>
            <div class="col-auto">
                <div class="table-filter-wrapper">
                    <slot name="filters" :mixins="self" :refresh-page="refreshPage" :filters="filters"></slot>
                </div>
            </div>
        </div>
        <div class="table-wrapper">
            <table>
                <thead>
                    <tr>
                        <th v-if="selectable">checkbox</th>
                        <slot name="thead" :mixins="self" :refresh-page="refreshPage"></slot>
                    </tr>
                </thead>
                <tbody>
                    <tr v-if="fetching">
                        <td :colspan="headerCount">
                            <i class="fa fa-spinner fa-spin pr-1"></i>
                            Loading data, please wait ...
                        </td>
                    </tr>
                    <tr v-else-if="recordsEmpty">
                        <td :colspan="headerCount">
                            No record was found
                        </td>
                    </tr>
                    <tr v-else v-for="(record, key) in pagination.data" :key="key">
                        <td v-if="selectable">
                            checkbox
                        </td>
                        <slot name="tbody" :record="record" :mixins="self" :refresh-page="refreshPage"></slot>
                    </tr>
                </tbody>
            </table>
        </div>
        
        <div class="table-pagination">
            <ul class="pagination">
                <li class="page-item">
                    <a class= "page-link">
                        <i class="fas fa-step-backward"></i>
                    </a>
                </li>
                <li v-for="(value, key) in [1,2,3,4,4]" :key="key" class="page-item">
                    <a class= "page-link" v-text="value"></a>
                </li>
                <li class="page-item">
                    <a class= "page-link">
                        <i class="fas fa-step-forward"></i>
                    </a>
                </li>
            </ul>
        </div>
    </div>
</template>
<script>
import mixins from 'utils/mixins';

export default {
    name: 'DataTable',
    components: {  },
    
    computed: {
        displayedTitle() {
            return this.searched ? `Search results for "${ this.lastSearch }"` : this.title;
        },

        displayedPages() {
            let pages = [];
            for (let page = 1; page <= (pagination.last_page || pagination.last); page++) {
                pages.push(this.formatPageData(page));
            }
            return pages;
        },

        headerCount() {
            return (this.$slots.header ? this.$slots.header.length : 1) + (this.selectable);
        },

        recordsEmpty() {
            return this.pagination.data && this.pagination.data.length == 0;
        },

    },

    props: {
        title: String,
        fetchLink: String,
        paginatePath: {
            type: String,
            default: "",
        },
        simplified: { type: Boolean, default: false },
        selectable:  {
            type: Boolean,
            default: false,
        },
    },

    mixins: [mixins],

    data: () => ({
        link: '',
        fetching: true,
        currentPage: 0,
        pagination: {},
        self: {},
        search: "",
        searched: false,
        lastSearch: "",
        filters: {},
    }),

    methods: {
        getPageClass(isActive) {
            return {
                'active': isActive,
                'page-item': true,
            };
        },
        
        startSearch() {
            this.searched = !!this.search && this.search.length > 0
            this.link = this.fetchLink;
            this.fetchData();
        },

        formatPageData(pageNumber) {
            return {
                active: this.currentPage == pageNumber,
                link: `${ this.pagination.path }?page=${ pageNumber }`,
                name: pageNumber,
            };
        },

        fetchData() {
            this.fetching = true;
            let params = this.searched ? { search: this.lastSearch = this.search  } : {};
            axios(this.link, { params })
                .then(response => this.mapData(response))
                .catch(error => this.fetchFailed(error))
                .finally(() => this.fetching = false);
        },

        fetchFailed(error) {
            this.$emit('fetch-failed', error);
            this.promptErrors(error.response.data.message);
            this.pagination = { data: [] };
        },

        mapData(response) {
            this.pagination =this.getPaginationFromPath(response);
            this.currentPage = this.pagination.current_page;
        },

        getPaginationFromPath(data) {
            this.paginatePath.split('.')
                .forEach(index => data = data[index]);
            return data;
        },
        
        movePage(event) {
            event.preventDefault();
            this.link = event.target.href
            this.currentPage = parseInt(event.target.dataset.page)
            this.fetchData();
        },

        refreshPage() {
            if (this.pagination.data.length <= 1) {
                let page = this.pagination.current_page - 1;
                this.link = this.pagination.path +
                    '?page=' + (page <= 0 ? 1 : page);
            }
            this.fetchData();
        },
        pageChanged(page){
            event.preventDefault();
            this.link = this.pagination.path +
                '?page=' + page;
            this.fetchData();
        },

    },


    mounted() {
        this.self = this;
        this.link = this.fetchLink;
        this.fetchData();
    },
}
</script>